Attribute VB_Name = "Module1"
Option Explicit

Public Sub ReadInSettings()

    Select Case ReadINI("Settings", "dc-tool")
        Case "IP":  intDctoolFlavor = IP
        Case Else:  intDctoolFlavor = SERIAL   'default to Serial
    End Select

    Select Case ReadINI("Settings", "Task")
        Case "U":   intDctoolTask = UL
        Case "D":   intDctoolTask = DL
        Case Else:  intDctoolTask = ULxEX  'default to UL & Exec
    End Select

    ' Filename
    If Command$ <> "" Then
        strFilename = Replace$(Command$, """", "")
    Else
        If ReadINI("Settings", "Filename") = "" Then
            strFilename = ""
        Else
            If FileExists(ReadINI("Settings", "Filename")) = True Then
                strFilename = ReadINI("Settings", "Filename")
            Else
                strFilename = ""
            End If
        End If
    End If
    
    ' Download Address
    Select Case ReadINI("Options", "Address")
        Case "":    strAddress = "0x8c010000"   'default
        Case Else:  strAddress = ReadINI("Options", "Address")
    End Select
    
    ' Filesize for Downloading
    Select Case ReadINI("Options", "Filesize")
        Case "":    strFilesize = "0x0"  'default
        Case Else:  strFilesize = ReadINI("Options", "Filesize")
    End Select
    
    ' dc-tool Serial Device
    Select Case ReadINI("Options", "Device")
        Case "":    strDevice = "COM1"  'default
        Case Else:  strDevice = ReadINI("Options", "Device")
    End Select
    
    ' dc-tool IP IP
    Select Case ReadINI("Options", "IP")
        Case "":    strIP = "192.168.1.137" 'default
        Case Else:  strIP = ReadINI("Options", "IP")
    End Select
    
    ' dc-tool Serial Baudrate
    Select Case ReadINI("Options", "Baudrate")
        Case "":    strBaudrate = "115200"  'default
        Case Else:  strBaudrate = ReadINI("Options", "Baudrate")
    End Select
    
    ' dc-tool IP ARP enabled \ disabled
    Select Case ReadINI("Options", "ARP")
        Case "":    intARP = vbUnchecked   'default
        Case Else:  intARP = ReadINI("Options", "ARP")
    End Select
    
    ' dc-tool IP ARP MAC Address
    Select Case ReadINI("Options", "MAC")
        Case "":    strMAC = ""    'default
        Case Else:  strMAC = ReadINI("Options", "MAC")
    End Select
    
    ' Start a GDB Server
    Select Case ReadINI("Options", "GDB")
        Case "":    intGDB = vbUnchecked   'default
        Case Else:  intGDB = ReadINI("Options", "GDB")
    End Select
    
    ' Don't attach Console \ Fileserver
    Select Case ReadINI("Options", "NoConsole")
        Case "":    intNoConsole = vbUnchecked   'default
        Case Else:  intNoConsole = ReadINI("Options", "NoConsole")
    End Select
    
    ' Dumb Terminal
    Select Case ReadINI("Options", "DumbTerminal")
        Case "":    intDumbTerminal = vbUnchecked 'default
        Case Else:  intDumbTerminal = ReadINI("Options", "DumbTerminal")
    End Select
    
    ' No Screen Clear before Download
    Select Case ReadINI("Options", "NoScreenClear")
        Case "":    intNoScreenClear = vbUnchecked   'default
        Case Else:  intNoScreenClear = ReadINI("Options", "NoScreenClear")
    End Select
    
    ' External clock
    Select Case ReadINI("Options", "ExternalClock")
        Case "":    intExternalClock = vbUnchecked   'default
        Case Else:  intExternalClock = ReadINI("Options", "ExternalClock")
    End Select
    
    ' CDFS redirection enabled \ disabled
    Select Case ReadINI("Options", "CDFSredir")
        Case "":    intCDFSRedir = vbUnchecked   'default
        Case Else:  intCDFSRedir = ReadINI("Options", "CDFSredir")
    End Select
    
    ' CDFS redirection ISO
    Select Case ReadINI("Options", "CDFSredirISO")
        Case "":    strCDFSRedirISO = ""   'default
        Case Else:  strCDFSRedirISO = ReadINI("Options", "CDFSredirISO")
    End Select
    
    ' Chroot enabled \ disabled
    'Select Case ReadINI("Options", "Chroot")
    '    Case "":    intChroot= vbUnchecked   'default
    '    Case Else:  intChroot = ReadINI("Options", "Chroot")
    'End Select
    
    ' Chroot to this folder
    'Select Case ReadINI("Options", "ChrootPath")
    '    Case "":    strChroot = ""  'default
    '    Case Else:  strChroot = ReadINI("Options", "ChrootPath")
    'End Select
    
    Set_GUI

End Sub

Public Sub WriteOutSettings()

    Select Case intDctoolFlavor
        Case IP:        Call WriteINI("Settings", "dc-tool", "IP")
        Case SERIAL:    Call WriteINI("Settings", "dc-tool", "Serial")
    End Select

    Select Case intDctoolTask
        Case UL:    Call WriteINI("Settings", "Task", "U")
        Case ULxEX: Call WriteINI("Settings", "Task", "UxE")
        Case DL:    Call WriteINI("Settings", "Task", "D")
    End Select
    
    Call WriteINI("Settings", "Filename", strFilename)
    
    ' Download Address
    Call WriteINI("Options", "Address", strAddress)
    
    ' Filesize for Downloading
    Call WriteINI("Options", "Filesize", strFilesize)
    
    ' dc-tool Serial Device
    Call WriteINI("Options", "Device", strDevice)
    
    ' dc-tool IP IP
    Call WriteINI("Options", "IP", strIP)
    
    ' dc-tool Serial Baudrate
    Call WriteINI("Options", "Baudrate", strBaudrate)
    
    ' dc-tool IP ARP enabled \ disabled
    Call WriteINI("Options", "ARP", CStr(intARP))
    
    ' dc-tool IP ARP MAC Address
    Call WriteINI("Options", "MAC", strMAC)
    
    ' Start a GDB Server
    Call WriteINI("Options", "GDB", CStr(intGDB))
    
    ' Don't attach Console \ Fileserver
    Call WriteINI("Options", "NoConsole", CStr(intNoConsole))
    
    ' Dumb Terminal
    Call WriteINI("Options", "DumbTerminal", CStr(intDumbTerminal))
    
    ' No Screen Clear before Download
    Call WriteINI("Options", "NoScreenClear", CStr(intNoScreenClear))
    
    ' External clock
    Call WriteINI("Options", "ExternalClock", CStr(intExternalClock))
    
    ' CDFS redirection enabled \ disabled
    Call WriteINI("Options", "CDFSredir", CStr(intCDFSRedir))
    
    ' CDFS redirection ISO
    Call WriteINI("Options", "CDFSredirISO", CStr(strCDFSRedirISO))
    
    ' Chroot enabled \ disabled
    'Call WriteINI("Options", "Chroot", CStr(intChroot))
    
    ' Chroot to this folder
    'Call WriteINI("Options", "ChrootPath", strChrootPath)

End Sub
